## collada2gltf 20140924

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(COLLADA2GLTF)

if (NOT WIN32)
#http://www.guyrutenberg.com/2014/01/05/enabling-c11-c0x-in-cmake/
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
if(COMPILER_SUPPORTS_CXX11)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
    message("-- C++11 Enabled")
elseif(COMPILER_SUPPORTS_CXX0X)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    message("-- C++0x Enabled")
else()
        message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
endif()
endif()

set(USE_OPEN3DGC "ON")
set(WITH_IN_SOURCE_BUILD "ON")
set(COLLADA2GLTF_BINARY_DIR, COLLADA2GLTF_SOURCE_DIR)
set(BUILD_SHARED_LIBS "OFF")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/GitSHA1.cpp.in" "${CMAKE_CURRENT_BINARY_DIR}/GitSHA1.cpp" @ONLY)

set(TARGET_LIBS GeneratedSaxParser_static OpenCOLLADABaseUtils_static UTF_static ftoa_static MathMLSolver_static OpenCOLLADASaxFrameworkLoader_static OpenCOLLADAFramework_static buffer_static)

if (NOT WIN32)
    set(CMAKE_FIND_LIBRARY_SUFFIXES .so .a .dylib)
endif()

# Lets libxml2 work in a shared library
add_definitions(-DLIBXML_STATIC_FOR_DLL)

IF(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64") 
 ADD_DEFINITIONS(-fPIC) 
ENDIF(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")

include_directories(${COLLADA2GLTF_SOURCE_DIR})
include_directories(${COLLADA2GLTF_SOURCE_DIR}/GLTF)
include_directories(${COLLADA2GLTF_SOURCE_DIR}/JSON)
include_directories(${COLLADA2GLTF_SOURCE_DIR}/shaders)
include_directories(${COLLADA2GLTF_SOURCE_DIR}/helpers)
include_directories(${COLLADA2GLTF_SOURCE_DIR}/convert)
include_directories(${COLLADA2GLTF_SOURCE_DIR}/assetModifiers)
include_directories(${COLLADA2GLTF_SOURCE_DIR}/dependencies/json/include/rapidjson)
include_directories(${COLLADA2GLTF_SOURCE_DIR}/dependencies/OpenCOLLADA/COLLADAFramework/include)
include_directories(${COLLADA2GLTF_SOURCE_DIR}/dependencies/OpenCOLLADA/COLLADABaseUtils/include)
include_directories(${COLLADA2GLTF_SOURCE_DIR}/dependencies/OpenCOLLADA/COLLADASaxFrameworkLoader/include)
include_directories(${COLLADA2GLTF_SOURCE_DIR}/dependencies/OpenCOLLADA/GeneratedSaxParser/include)
if (WIN32)
    include_directories(${COLLADA2GLTF_SOURCE_DIR}/dependencies/misc)
endif()

if (USE_OPEN3DGC)
    add_definitions( -DUSE_OPEN3DGC )
    include_directories(${COLLADA2GLTF_SOURCE_DIR}/extensions/o3dgc-compression)

    include_directories(${COLLADA2GLTF_SOURCE_DIR}/dependencies/o3dgc/src)
    include_directories(${COLLADA2GLTF_SOURCE_DIR}/dependencies/o3dgc/src/o3dgc_common_lib/inc)
    include_directories(${COLLADA2GLTF_SOURCE_DIR}/dependencies/o3dgc/src/o3dgc_encode_lib/inc)
    include_directories(${COLLADA2GLTF_SOURCE_DIR}/dependencies/o3dgc/src/o3dgc_decode_lib/inc)
endif()

find_package(PNG)
if (PNG_FOUND)
    include_directories(${PNG_INCLUDE_DIR})
    include_directories(${ZLIB_INCLUDE_DIR})
    add_definitions(-DUSE_LIBPNG)
else()
    message(WARNING "libpng or one of its dependencies couldn't be found. Transparency may not be correctly detected.")
endif()

link_directories(${COLLADA2GLTF_BINARY_DIR}/lib)

if (WIN32)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_definitions(-DWIN32)
    add_definitions(-EHsc)
endif()

add_subdirectory(dependencies/OpenCOLLADA)

if (USE_OPEN3DGC)
    add_subdirectory(dependencies/o3dgc/src)
endif()

set(GLTF_SOURCES
    COLLADA2GLTFWriter.h
    COLLADA2GLTFWriter.cpp
    GLTFOpenCOLLADA.h
    GLTFOpenCOLLADAUtils.h
    GLTFOpenCOLLADAUtils.cpp

    GLTF/GLTFAccessorCache.cpp
    GLTF/GLTFAccessorCache.h
    GLTF/GLTFAsset.cpp
    GLTF/GLTFAnimation.cpp
    GLTF/GLTFAccessor.cpp
    GLTF/GLTFBuffer.cpp
    GLTF/GLTFEffect.cpp
    GLTF/GLTFExtras.cpp
    GLTF/GLTFMesh.cpp
    GLTF/GLTFPrimitive.cpp
    GLTF/GLTFUtils.cpp
    GLTF/GLTFWriter.cpp
    GLTF/GLTFSkin.cpp
    GLTF/GLTF.h
    GLTF/GLTFTypesAndConstants.h
    GLTF/GLTFAsset.h
    GLTF/GLTFAnimation.h
    GLTF/GLTFAccessor.h
    GLTF/GLTFBuffer.h
    GLTF/GLTFEffect.h
    GLTF/GLTFExtras.h
    GLTF/GLTFMesh.h
    GLTF/GLTFPrimitive.h
    GLTF/GLTFUtils.h
    GLTF/GLTFWriter.h
    GLTF/GLTFSkin.h
    GLTF/GLTFExtraDataHandler.h
    GLTF/GLTFExtraDataHandler.cpp
    GLTF/GLTFProfile.h
    GLTF/GLTFProfile.cpp
    GLTF/GLTFInputStream.h
    GLTF/GLTFInputStream.cpp
    GLTF/GLTFOutputStream.h
    GLTF/GLTFOutputStream.cpp
    GLTF/GLTFConfig.cpp
    GLTF/GLTFConfig.h

    profiles/webgl-1.0/webgl-idl.h
    profiles/webgl-1.0/GLTFWebGL_1_0_Profile.cpp
    profiles/webgl-1.0/GLTFWebGL_1_0_Profile.h

    shaders/commonProfileShaders.h
    shaders/commonProfileShaders.cpp

    helpers/geometryHelpers.h
    helpers/geometryHelpers.cpp
    helpers/mathHelpers.h
    helpers/mathHelpers.cpp
    helpers/encodingHelpers.h
    helpers/encodingHelpers.cpp

    convert/meshConverter.cpp
    convert/meshConverter.h
    convert/animationConverter.cpp
    convert/animationConverter.h

    JSON/JSONArray.cpp
    JSON/JSONNumber.cpp
    JSON/JSONObject.cpp
    JSON/JSONString.cpp
    JSON/JSONValue.cpp
    JSON/JSONArray.h
    JSON/JSONNumber.h
    JSON/JSONObject.h
    JSON/JSONString.h
    JSON/JSONValue.h
    
    assetModifiers/GLTFAssetModifier.h
    assetModifiers/GLTFFlipUVModifier.h
    assetModifiers/GLTFFlipUVModifier.cpp

    ${CMAKE_CURRENT_BINARY_DIR}/GitSHA1.cpp
    GitSHA1.h)

if (USE_OPEN3DGC)
LIST(APPEND GLTF_SOURCES
    extensions/o3dgc-compression/GLTF-Open3DGC.cpp
    extensions/o3dgc-compression/GLTF-Open3DGC.h)
endif()

option(CONVERT_SHARED "CONVERT_SHARED" OFF)
if (CONVERT_SHARED)
    add_library(collada2gltfConvert SHARED ${GLTF_SOURCES})
    #Make sure the dll is in the same directory as the executable
    if (WIN32)
        set_target_properties(collada2gltfConvert PROPERTIES RUNTIME_OUTPUT_DIRECTORY "bin")
    endif()
else()
    add_library(collada2gltfConvert STATIC ${GLTF_SOURCES})
    add_definitions(-DSTATIC_COLLADA2GLTF)
endif()

if (PNG_FOUND)
    LIST(APPEND TARGET_LIBS ${PNG_LIBRARY} ${ZLIB_LIBRARY})
endif()

if (USE_OPEN3DGC)
LIST(APPEND TARGET_LIBS o3dgc_common_lib o3dgc_enc_lib o3dgc_dec_lib)
endif()

IF("${CMAKE_SYSTEM}" MATCHES "Linux")
    LIST(APPEND TARGET_LIBS rt)
endif("${CMAKE_SYSTEM}" MATCHES "Linux")

target_link_libraries (collada2gltfConvert ${TARGET_LIBS})

set(GLTF_EXE_SOURCES  main.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/GitSHA1.cpp
    GitSHA1.h)

if (WIN32)
LIST(APPEND GLTF_EXE_SOURCES ${COLLADA2GLTF_SOURCE_DIR}/dependencies/misc/getopt_long.c ${COLLADA2GLTF_SOURCE_DIR}/dependencies/misc/getopt.c ${COLLADA2GLTF_SOURCE_DIR}/dependencies/misc/getopt.h)
endif()

add_executable(collada2gltf ${GLTF_EXE_SOURCES})
target_link_libraries (collada2gltf collada2gltfConvert)

=== dependencies/o3dgc/src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6.0 FATAL_ERROR)
project(o3dgc)
set(CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/output" CACHE PATH "project install prefix" FORCE)
set(CMAKE_COMMON_INC "${${PROJECT_NAME}_SOURCE_DIR}/../scripts/cmake_common.cmake")
add_subdirectory ("${${PROJECT_NAME}_SOURCE_DIR}/o3dgc_common_lib")
add_subdirectory ("${${PROJECT_NAME}_SOURCE_DIR}/o3dgc_encode_lib")
add_subdirectory ("${${PROJECT_NAME}_SOURCE_DIR}/o3dgc_decode_lib")
add_subdirectory ("${${PROJECT_NAME}_SOURCE_DIR}/test")

=== dependencies/o3dgc/src/test/CMakeLists.txt ===
project(O3DGC_TEST)
include(${CMAKE_COMMON_INC})
add_executable(test_o3dgc ${PROJECT_CPP_FILES} ${PROJECT_C_FILES} ${PROJECT_INC_FILES} ${PROJECT_INL_FILES})

include_directories("${${PROJECT_NAME}_SOURCE_DIR}/../o3dgc_decode_lib/inc" "${${PROJECT_NAME}_SOURCE_DIR}/../o3dgc_encode_lib/inc" "${${PROJECT_NAME}_SOURCE_DIR}/../o3dgc_common_lib/inc")

target_link_libraries(test_o3dgc o3dgc_dec_lib o3dgc_enc_lib o3dgc_common_lib)
IF(WIN32)
target_link_libraries(test_o3dgc o3dgc_common_lib)
ELSEIF(APPLE)
target_link_libraries(test_o3dgc o3dgc_common_lib)
ELSE ()
set(CMAKE_CXX_FLAGS "-g -Wall")
target_link_libraries(test_o3dgc o3dgc_common_lib rt)
ENDIF()

=== debian/changelog ===
collada2gltf (20140924-8) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since stretch:
    + Build-Depends: Drop versioned constraint on dh-exec.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 20 Aug 2021 13:39:53 +0100

collada2gltf (20140924-7) unstable; urgency=low

  * QA upload.

  [ Debian Janitor ]
  * Remove CRs from copyright file.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sat, 13 Feb 2021 04:09:18 +0000

collada2gltf (20140924-6) unstable; urgency=medium

  * QA upload.

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces
  * d/rules: Remove trailing whitespaces

  [ Sudip Mukherjee ]
  * Fix FTBFS with rapidjson. (Closes: #893203)
  * Update Standards-Version to 4.5.0
  * Use debhelper-compat.
    - Update to compat level 13.
  * Remove whitespace from d/control and d/rules.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 03 Jul 2020 18:26:49 +0100

collada2gltf (20140924-5) unstable; urgency=medium

  * add Vcs-* fields (closes: #888664)
  * move Maintainer to QA

 -- Rene Engelhard <rene@debian.org>  Mon, 12 Feb 2018 21:31:37 +0100

collada2gltf (20140924-4) unstable; urgency=medium

  [ Matteo F. Vescovi ]
  * [12ab946] Fix typo in "Description:" field

  [ Rene Engelhard ]
  * [08624cc] multiarchify

 -- Rene Engelhard <rene@debian.org>  Tue, 06 Sep 2016 19:31:01 +0200

collada2gltf (20140924-3) unstable; urgency=medium

  * *really* build-depend on opencollada-dev (>= 0.1.0~20140703.ddf8f47+dfsg1-2)
    and also bump it in Depends:

 -- Rene Engelhard <rene@debian.org>  Sun, 09 Aug 2015 14:35:33 +0200

collada2gltf (20140924-2) unstable; urgency=medium

  * rebuild with gcc 5

  * build-depend on opencollada-dev (>= 0.1.0~20140703.ddf8f47+dfsg1-2)

 -- Rene Engelhard <rene@debian.org>  Sun, 02 Aug 2015 12:46:49 +0200

collada2gltf (20140924-1) unstable; urgency=low

  * Initial release (Closes: #763445)

 -- Rene Engelhard <rene@debian.org>  Thu, 14 May 2015 13:34:42 +0200

=== debian/control ===
Source: collada2gltf
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13), cmake, opencollada-dev (>= 0.1.0~20140703.ddf8f47+dfsg1-2), rapidjson-dev, libo3dgc-dev, libpng-dev, zlib1g-dev, dh-exec
Standards-Version: 4.5.0
Section: libs
Vcs-Git: https://salsa.debian.org/debian/collada2gltf.git
Vcs-Browser: https://salsa.debian.org/debian/collada2gltf

Package: libcollada2gltfconvert-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: opencollada-dev (>= 0.1.0~20140703.ddf8f47+dfsg1-2), rapidjson-dev, ${misc:Depends}
Description: COLLADA to glTF conversion library -- development
 glTF, the GL Transmission Format, is the runtime asset format for the GL APIs:
 WebGL, OpenGL ES, and OpenGL. glTF bridges the gap between formats used by
 modeling tools and the GL APIs.
 .
 COLLADA2GLTF converts COLLADA files to glTF.
 .
 This package contains the headers and static libraries for converting COLLADA
 to glTF in your applications.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# main packaging script based on dh7 syntax
%:
	dh $@

override_dh_install:
	dh_install --sourcedir=$(CURDIR)

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- \
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)
